diff --git a/cpp/orm_engine/schema.cpp b/cpp/orm_engine/schema.cpp
index 3246d7777d..fbb5b0d16b 100644
--- a/cpp/orm_engine/schema.cpp
+++ b/cpp/orm_engine/schema.cpp
@@ -31,6 +31,7 @@ SchemaRegistry& SchemaRegistry::instance() {
 
 ModelId SchemaRegistry::register_model(ModelSchema schema) {
   index_fields(schema);
+  ++generation_;
   if (auto it = by_label_.find(schema.label); it != by_label_.end()) {
     ModelId id = it->second;
     schema.id = id;
@@ -70,6 +71,7 @@ std::optional<ModelId> SchemaRegistry::find_id(std::string_view label) const {
 void SchemaRegistry::clear() {
   models_.clear();
   by_label_.clear();
+  ++generation_;
 }
 
 FieldType field_type_from_class_name(std::string_view class_name) {
@@ -79,11 +81,11 @@ FieldType field_type_from_class_name(std::string_view class_name) {
   if (class_name == "BigAutoField") {
     return FieldType::BigAuto;
   }
-  if (class_name == "IntegerField" || class_name == "PositiveIntegerField" ||
-      class_name == "PositiveSmallIntegerField") {
+  if (class_name == "IntegerField" || class_name == "PositiveIntegerField") {
     return FieldType::Integer;
   }
-  if (class_name == "SmallIntegerField") {
+  if (class_name == "SmallIntegerField" ||
+      class_name == "PositiveSmallIntegerField") {
     return FieldType::SmallInteger;
   }
   if (class_name == "BigIntegerField" || class_name == "PositiveBigIntegerField") {
@@ -142,4 +144,21 @@ RelKind rel_kind_from_string(std::string_view s) {
   return RelKind::None;
 }
 
+bool field_type_has_direct_primitive_prep(FieldType type) {
+  switch (type) {
+    case FieldType::Integer:
+    case FieldType::BigInteger:
+    case FieldType::SmallInteger:
+    case FieldType::Auto:
+    case FieldType::BigAuto:
+    case FieldType::Float:
+    case FieldType::Boolean:
+    case FieldType::Text:
+    case FieldType::Char:
+      return true;
+    default:
+      return false;
+  }
+}
+
 }  // namespace django::orm
diff --git a/cpp/orm_engine/schema.hpp b/cpp/orm_engine/schema.hpp
index ecbeed07bc..127d9d0267 100644
--- a/cpp/orm_engine/schema.hpp
+++ b/cpp/orm_engine/schema.hpp
@@ -50,6 +50,11 @@ struct FieldSchema {
   FieldType type = FieldType::Other;
   bool primary_key = false;
   bool nullable = false;
+  // True only when Django's exact built-in field class has identity/simple
+  // primitive preparation semantics. Custom subclasses deliberately remain
+  // false even when get_internal_type() reports a built-in type.
+  bool native_direct = false;
+  bool generated = false;
 
   RelKind rel = RelKind::None;
   std::string remote_table;
@@ -63,6 +68,9 @@ struct FieldSchema {
   std::string m2m_reverse_column;  // through col → remote model
 
   [[nodiscard]] bool is_relation() const { return rel != RelKind::None; }
+  [[nodiscard]] bool is_native_scalar() const {
+    return native_direct && !generated && !is_relation() && !column.empty();
+  }
 };
 
 struct ModelSchema {
@@ -84,15 +92,19 @@ class SchemaRegistry {
   [[nodiscard]] const ModelSchema* get_by_label(std::string_view label) const;
   [[nodiscard]] std::optional<ModelId> find_id(std::string_view label) const;
 
+  [[nodiscard]] std::uint64_t generation() const { return generation_; }
+
   void clear();
 
  private:
   SchemaRegistry() = default;
   std::vector<ModelSchema> models_;
   std::unordered_map<std::string, ModelId> by_label_;
+  std::uint64_t generation_ = 0;
 };
 
 [[nodiscard]] FieldType field_type_from_class_name(std::string_view class_name);
 [[nodiscard]] RelKind rel_kind_from_string(std::string_view s);
+[[nodiscard]] bool field_type_has_direct_primitive_prep(FieldType type);
 
 }  // namespace django::orm
diff --git a/django/apps/registry.py b/django/apps/registry.py
index 7579fca758..df567e3004 100644
--- a/django/apps/registry.py
+++ b/django/apps/registry.py
@@ -124,6 +124,20 @@ class Apps:
                 app_config.ready()
 
             self.ready = True
+            # Native ORM schema export is a cold startup operation. Keeping it
+            # here avoids walking model._meta and rebuilding C++ schemas on
+            # every query. Unsupported/dynamic models still register lazily.
+            try:
+                from django.native._loader import AVAILABLE as native_available
+
+                if native_available:
+                    from django.native.orm import initialize_schema_registry
+
+                    initialize_schema_registry(self)
+            except Exception:
+                # Schema export is an optimization; never make app population
+                # fail when a third-party model exposes unusual metadata.
+                pass
             self.ready_event.set()
 
     def check_apps_ready(self):
